--[[
BlackJack
version 1.0
LUA 5.1.1
written by CrazyGuy
based on a C++ Template
Last updated on January 26th 2007

version 1.1
Changed: Hiding house's score
Last updated on January 27th 2007

version 2.0
Converted to HexHub script
requires HexLUA511.dll by bleubear
requires HexHub 3.19 or higher
Last updated on March 1st 2007
]]--

--Variables (edit at will)
sBotName = "BlackJack"	--botname
iJoinTime = 30				--time players have to join a gome in seconds
cmdStartGame = "bj_start"	--command to setup a new game
cmdJoinGame = "bj_join"		--command to join a newly setup game
iBotID = 0
iCmdS = -1
iCmdJ = -1
--Statics, Do NOT edit

tPlayers = {}
tHands = {}
tDeck = {}
tCards = { "Ac", "2c", "3c", "4c", "5c", "6c", "7c", "8c", "9c", "10c", "Jc", "Qc", "Kc", "Ad", "2d", "3d", "4d", "5d", "6d", "7d", "8d", "9d", "10d", "Jd", "Qd", "Kd", "Ah", "2h", "3h", "4h", "5h", "6h", "7h", "8h", "9h", "10h", "Jh", "Qh", "Kh", "As", "2s", "3s", "4s", "5s", "6s", "7s", "8s", "9s", "10s", "Js", "Qs", "Ks" }
tPoints = {
	["A"] = 1,		-- Ace is 1 or 11 but gives standard 1. GetScores() checks wether player busts on 11 or not
	["2"] = 2,
	["3"] = 3,
	["4"] = 4,
	["5"] = 5,
	["6"] = 6,
	["7"] = 7,
	["8"] = 8,
	["9"] = 9,
	["1"] = 10,		-- this is actually the 10 card. But as i take a substring with length 1 when checking points, and a 1-card doesn't exist, i can do it like this
	["J"] = 10,
	["Q"] = 10,
	["K"] = 10,
	["X"] = 20,		-- bust score for removed user
}

iMaxPlayers = 7
iCurPlayer = 0

bHideHouse = 1

sStartMessage = "To start a new game of BlackJack, type "..cmdStartGame.." in main."
sStartupMessage = "\tWelcome to BlackJack\n\nType " ..cmdJoinGame.." to join this play (Max 7 players).\nThis game will auto-start with its current players after "..iJoinTime.." seconds.\n\n"
sAskCard = " ,do you want another card ? (Y/N)"

OnInit = function()
	iBotID = HexHub.RegisterBot(sBotName)
	if iBotID then
		HexHub.SendToAll("<"..sBotName.."> "..sStartMessage.."|")
		iCmdS = HexHub.RegisterCommand(cmdStartGame)
		iCmdJ = HexHub.RegisterCommand(cmdJoinGame)
		if iCmdS and iCmdJ then
			return 0
		else
			return 1
		end
	else
		return 1
	end
end

OnError = function(sError)
	HexHub.SendToAll("<"..sBotName.."> "..sError.."|")
	return 0
end

OnTimer = function()
	Plug.KillTimer()
	if iCurPlayer == 0 then
		local sWelcome = "It's TIME to play BLACKJACK !!!\nThe following players are sitting at the table:\n\n"
		for k in pairs(tPlayers) do
			sWelcome = sWelcome..", "..tPlayers[k]
		end
		sWelcome = sWelcome.."\n\n\tLet the games begin, and Good Luck !!!\n"
		HexHub.SendToAll("<"..sBotName.."> "..sWelcome.."|")
		StartPlay()
	else
		if IdFromNick(tPlayers[iCurPlayer]) then
			--player returned, re ask question
			ShowCurPlayer(iCurPlayer)
			HexHub.SendToAll("<"..sBotName.."> "..tPlayers[iCurPlayer]..sAskCard.."|")
		else
			--player did not return
			HexHub.SendToAll("<"..sBotName.."> Unfortunatly, "..tPlayers[iCurPlayer].." seemed not to be able to return. Moving on game.|")
			tHands[tPlayers[iCurPlayer]] = { "XX", "XX" }
			iCurPlayer = iCurPlayer + 1
			if iCurPlayer == table.getn(tPlayers) then
				--the house plays
				DoHouseMove()
				--declare winner(s)
				HexHub.SendToAll("<"..sBotName.."> Let's have a look at the scores:|")
				DeclareWinners()
				--clean up after the game
				CleanUpAfter()
				HexHub.SendToAll("<"..sBotName.."> I'm ready for another game ! type"..cmdStartGame.."|")
			else
				--ask the next player if he/she wants a card
				ShowCurPlayer(iCurPlayer)
				HexHub.SendToAll("<"..sBotName.."> "..tPlayers[iCurPlayer]..sAskCard.."|")
			end
		end
	end
end

function OnRegisteredCommand(iCommandId, iUserId, sData, bIsPM)
	if iCommandId == iCmdS then
		if table.getn(tPlayers) == 0 then
			-- start a new game
			AddPlayer(HexHub.NickFromId(iUserId))
			HexHub.SendToAll("<"..sBotName.."> "..sStartupMessage.."|")
			Plug.SetTimer((iJoinTime*1000),(iJoinTime*1000))
		else
			-- tell the user a game is in progress
			HexHub.SendTo(iUserId,"<"..sBotName.."> A game is currently in progress. Please wait for the game to be finished.|")
		end
	elseif iCommandId == iCmdJ then
		-- check if a game has been initialized
		if table.getn(tPlayers) ~= 0 then
			if tHands[HexHub.NickFromId(iUserId)] then
				-- tell the user he can't enter the game twice
				HexHub.SendTo(iUserId,"<"..sBotName.."> You are already participating in this game and will not be added again.|")
			else
				--check if the game didn't start already
				if iCurPlayer == 0 then
					-- check if max players isn't reached
					if table.getn(tPlayers) < iMaxPlayers then
						-- add the player
						AddPlayer(HexHub.NickFromId(iUserId))
						HexHub.SendTo(iUserId,"<"..sBotName.."> You have been added to the table. Good Luck !|")
						if table.getn(tPlayers) == iMaxPlayers then
							-- we got max players now, let's start
							Plug.KillTimer()
							local sWelcome = "FULL TABLE & It's TIME to play BLACKJACK !!!\nThe following players are sitting at the table:\n\n"
							for k in pairs(tPlayers) do
								sWelcome = sWelcome..", "..tPlayers[k]
							end
							sWelcome = sWelcome.."\n\n\tLet the games begin, and Good Luck !!!\n"
							HexHub.SendToAll("<"..sBotName..">  "..sWelcome.."|")
							StartPlay()
						end
					else
						HexHub.SendTo(iUserId,"<"..sBotName.."> I'm sorry, this table is full. Please wait for the next game.|")
					end
				else
					--tell the player he's too late
					HexHub.SendTo(iUserId,"<"..sBotName.."> I'm sorry, the game is already in progress. Please wait for the game to be finished.|")
				end
			end
		else
			-- auto-start a new game
			AddPlayer(HexHub.NickFromId(iUserId))
			HexHub.SendToAll("<"..sBotName.."> "..sStartupMessage.."|")
			Plug.SetTimer((iJoinTime*1000),(iJoinTime*1000))
		end
	end	
end

OnChatMessage = function(iUserId, sData)	
	local _,_,cmd = string.find(sData, "%b<>%s(%S)")
	if string.lower(cmd) == "n" and HexHub.NickFromId(iUserId) == tPlayers[iCurPlayer] then
		-- take action on current player not wanting a next card
		HexHub.SendToAll("<"..sBotName.."> "..tPlayers[iCurPlayer].." decides to stand on "..GetTotal(tPlayers[iCurPlayer])..".|")
		iCurPlayer = iCurPlayer + 1
		if iCurPlayer == table.getn(tPlayers) then
			--the house plays
			DoHouseMove()
			--declare winner(s)
			HexHub.SendToAll("<"..sBotName.."> Let's have a look at the scores:\n|")
			DeclareWinners()
			--clean up after the game
			CleanUpAfter()
			HexHub.SendToAll("<"..sBotName.."> I'm ready for another game ! type "..cmdStartGame.."|")
		else
			--ask the next player if he/she wants a card
			ShowCurPlayer(iCurPlayer)
			if IdFromNick(tPlayers[iCurPlayer]) then
				HexHub.SendToAll("<"..sBotName.."> "..tPlayers[iCurPlayer]..sAskCard.."|")
			else
				HexHub.SendToAll("<"..sBotName.."> "..tPlayers[iCurPlayer].." seems to be offline. We will wait "..iJoinTime.." seconds for his/her return.|")
				Plug.SetTimer((iJoinTime*1000),(iJoinTime*1000))
			end
		end
		return false
	elseif string.lower(cmd) == "y" and HexHub.NickFromId(iUserId) == tPlayers[iCurPlayer] then
		-- give user a new card
		HexHub.SendToAll("<"..sBotName.."> "..tPlayers[iCurPlayer].." wants another card.|")
		DealCard(iCurPlayer)
		--show new card
		ShowCurPlayer(iCurPlayer)
		--check if player is bust or not. If not, ask if player wants another card, otherwise move on to next player
		if GetTotal(tPlayers[iCurPlayer]) > 21 then
			HexHub.SendToAll("<"..sBotName.."> "..tPlayers[iCurPlayer].." busts.|")
			iCurPlayer = iCurPlayer + 1
			if iCurPlayer == table.getn(tPlayers) then
				--the house plays
				DoHouseMove()
				--declare winner(s)
				HexHub.SendToAll("<"..sBotName.."> Let's have a look at the scores:\n|")
				DeclareWinners()
				--clean up after the game
				CleanUpAfter()
				HexHub.SendToAll("<"..sBotName.."> I'm ready for another game ! type "..cmdStartGame.."|")
			else
				--ask the next player if he/she wants a card
				ShowCurPlayer(iCurPlayer)
				if IdFromNick(tPlayers[iCurPlayer]) then
					HexHub.SendToAll("<"..sBotName.."> "..tPlayers[iCurPlayer]..sAskCard.."|")
				else
					HexHub.SendToAll("<"..sBotName.."> "..tPlayers[iCurPlayer].." seems to be offline. We will wait "..iJoinTime.." for his/her return.|")
					Plug.SetTimer((iJoinTime*1000),(iJoinTime*1000))
				end
			end
		else
			HexHub.SendToAll("<"..sBotName.."> "..tPlayers[iCurPlayer]..sAskCard.."|")
		end
		return false
	end
	return true
end

Shuffle = function()
	tDeck = { "Ac", "2c", "3c", "4c", "5c", "6c", "7c", "8c", "9c", "10c", "Jc", "Qc", "Kc", "Ad", "2d", "3d", "4d", "5d", "6d", "7d", "8d", "9d", "10d", "Jd", "Qd", "Kd", "Ah", "2h", "3h", "4h", "5h", "6h", "7h", "8h", "9h", "10h", "Jh", "Qh", "Kh", "As", "2s", "3s", "4s", "5s", "6s", "7s", "8s", "9s", "10s", "Js", "Qs", "Ks" }
	math.randomseed(os.time())
	for k = 1,52 do
		local pos = math.random(52)
		local card = tDeck[pos]
		table.remove(tDeck, pos)
		table.insert(tDeck, card)
	end
	HexHub.SendToAll("<"..sBotName.."> Shuffeling deck...|")
end

ShowCurPlayer = function(iPlayer)
	local sShow = tPlayers[iPlayer].." has the following cards:\t"
	for k in pairs(tHands[tPlayers[iPlayer]]) do
		if tPlayers[iPlayer] ~= "The House" then
			sShow = sShow..tHands[tPlayers[iPlayer]][k].."\t"
		else
			-- hide House's first card
			if k == 1 and bHideHouse == 1 then
				sShow = sShow.."XX\t"
			else
				sShow = sShow..tHands[tPlayers[iPlayer]][k].."\t"
			end
		end
	end
	if tPlayers[iPlayer] == "The House" and bHideHouse == 1 then
		HexHub.SendToAll("<"..sBotName.."> "..sShow.."( XX points )|")
	else
		HexHub.SendToAll("<"..sBotName.."> "..sShow.."( "..GetTotal(tPlayers[iPlayer]).." points )|")
	end
end

StartPlay = function()
	-- add the dealer
	AddPlayer("The House")
	-- shuffle the cards
	Shuffle()
	-- set current player
	iCurPlayer = 1
	--Deal all players 2 cards, and show them
	for k in pairs(tPlayers) do
		DealCard(k)
		DealCard(k)
		ShowCurPlayer(k)
	end
	-- ask the first player, if he/she wants another card
	if IdFromNick(tPlayers[iCurPlayer]) then
		HexHub.SendToAll("<"..sBotName.."> "..tPlayers[iCurPlayer]..sAskCard.."|")
	else
		HexHub.SendToAll("<"..sBotName.."> "..tPlayers[iCurPlayer].." seems to be offline. We will wait "..iJoinTime.." seconds for his/her return.|")
		Plug.SetTimer((iJoinTime*1000),(iJoinTime*1000))
	end
end

GetTotal = function(sPlayerName)
	local points = 0
	local bHasAce = 0
	for k in pairs(tHands[sPlayerName]) do
		points = points + tPoints[string.sub(tHands[sPlayerName][k],1,1)]
		if string.sub(tHands[sPlayerName][k],1,1) == "A" then bHasAce = 1 end
	end
	-- if player has an ace, and it wont bust him if he counts it as 11, then count it as 11  (adding 10 because 1 was already added)
	if bHasAce == 1 and points <= 11 then points = points + 10 end
	return points
end

DealCard = function(iPlayer)
	local icard = table.getn(tHands[tPlayers[iPlayer]]) + 1
	local card = table.remove(tDeck)
	tHands[tPlayers[iPlayer]][icard] = card
end

AddPlayer = function(sPlayerName)
	table.insert(tPlayers, sPlayerName)
	tHands[sPlayerName] = {}
	HexHub.SendToAll("<"..sBotName.."> "..sPlayerName.." has joined the table.|")
end

DoHouseMove = function()
	-- House takes a card on 16 or less and stands on 17 or more
	bHideHouse = 0
	ShowCurPlayer(iCurPlayer)
	while GetTotal(tPlayers[iCurPlayer]) <= 16 do
		DealCard(iCurPlayer)
		ShowCurPlayer(iCurPlayer)
	end
	if GetTotal(tPlayers[iCurPlayer]) <= 21 then
		HexHub.SendToAll("<"..sBotName.."> The House stands on "..GetTotal(tPlayers[iCurPlayer]).."|")
	else
		HexHub.SendToAll("<"..sBotName.."> The House busts.|")
	end
end

CleanUpAfter = function()
	iCurPlayer = 0
	bHideHouse = 1
	tHands = {}
	tDeck = {}
	tPlayers = {}
end

DeclareWinners = function()
	--check first if the house is busted
	if GetTotal(tPlayers[iCurPlayer]) > 21 then
		-- house is busted, all players not busted win
		for k in pairs(tPlayers) do
			--dont check the house again
			if k ~= table.getn(tPlayers) then
				if GetTotal(tPlayers[k]) <= 21 then
					-- declare player a winner
					HexHub.SendToAll("<"..sBotName.."> "..tPlayers[k].." wins!!|")
				else
					--the player lost as well
					HexHub.SendToAll("<"..sBotName.."> "..tPlayers[k].." loses :(|")
				end
			end
		end
	else
		--compare players score with houses
		for k in pairs(tPlayers) do
			-- skip the house
			if k ~= table.getn(tPlayers) then
				--if player is not busted
				if GetTotal(tPlayers[k]) <= 21 then
					-- if player's score is higher than houses, declare him/her a winner
					if GetTotal(tPlayers[k]) > GetTotal(tPlayers[iCurPlayer]) then
						HexHub.SendToAll("<"..sBotName.."> "..tPlayers[k].." wins!!|")
					elseif GetTotal(tPlayers[k]) == GetTotal(tPlayers[iCurPlayer]) then
						--if the player scores equal with the house, he/she pushes
						HexHub.SendToAll("<"..sBotName.."> "..tPlayers[k].." pushes.|")
					else
						--the player loses
						HexHub.SendToAll("<"..sBotName.."> "..tPlayers[k].." loses :(|")
					end
				else
					--player's busted, he/she auto-loses
					HexHub.SendToAll("<"..sBotName.."> "..tPlayers[k].." loses :(|")
				end
			end
		end
	end
end

function IdFromNick(sNick)
	local iIdsCount = Plug.EnumUserIds()
	local sTmp = nil
	local curId = Plug.EnumGetNext()
	while (curId ~= -1) do
		sTmp = HexHub.NickFromId(curId)
		if sTmp then
			if sNick == sTmp then
				return curId
			end
		end		
		curId = Plug.EnumGetNext()
	end
	return nil
end